using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CannonControls : MonoBehaviour
{
    [SerializeField] private GameObject projectile = null;
    [SerializeField] private float shootingDelay = 0.2f;
    [SerializeField] private Collider[] cannonColliders = null;
    private float delay;
    private float timeLeftToShoot = 0f; // the amount of time passed since last shot

    void Start()
    {
        delay = shootingDelay;
    }

    void Update()
    {
        if(Input.GetKey(KeyCode.Space))
        {
            if (timeLeftToShoot <= 0f)
            {
                // start shooting cannonballs
                GameObject childObject = Instantiate(projectile) as GameObject;
                foreach (Collider collider in cannonColliders)
                    Physics.IgnoreCollision(childObject.GetComponent<Collider>(), collider, true);
                childObject.transform.parent = gameObject.transform;
                childObject.transform.localPosition = new Vector3(0, 0, 0);
                childObject.transform.LookAt(GameObject.Find("Shooting Target").transform);
                if(delay > (shootingDelay * 1f) / 2f)
                    delay *= 0.95f;
                timeLeftToShoot = delay;
            }
            else
            {
                timeLeftToShoot -= Time.deltaTime;
            }
        }
        if (Input.GetKeyUp(KeyCode.Space))
        {
            delay = shootingDelay;
            timeLeftToShoot = 0f;
        }
    }
}
