﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Stack : MonoBehaviour
{
    [SerializeField] private int numberOfNodes;
    [HideInInspector] public int nodesLeft;
    
    private NodeHolder nodeHolder = null;

    void Awake()
    {
        nodeHolder = gameObject.transform.GetChild(0).GetComponent<NodeHolder>();
        refreshStack(numberOfNodes);
    }

    private void refreshStack(int nodeCount)
    {
        numberOfNodes = nodesLeft = nodeCount;
        nodeHolder.MakeNodes(numberOfNodes);
    }

    private void OnCollisionEnter(Collision collision)
    {
        if (collision.gameObject.tag == "Cannonball")
        {
            GameEvents.instance.TriggerOnHitEvent();
            // Destroy the last stack node
            Destroy(collision.gameObject);
            nodeHolder.RemoveBottomNode();
            nodesLeft--;

            if(nodesLeft == 0)
            {
                refreshStack((int)(numberOfNodes * 1.5f));
            }
        }
    }
}
